/* ************************************************** */
/* REXX script to modify a resource definition        */
/* so that it will specify an OS/2 Warp v4.0 notebook */
/*                                                    */
/* Written by Stephane Bessette, 12/02/98             */
/* ************************************************** */
'@echo off'


/* ************************* */
/* Name of the resource file */
/* ************************* */
Resource = "Resource"


/* ********************** */
/* Create a backup of .rc */
/* ********************** */
'if exist ' || Resource || '.bak del ' || Resource || '.bak'
'ren ' || Resource || '.rc ' || Resource || '.bak'


/* ************************** */
/* Process every line of .bak */
/* ************************** */
do while lines( Resource || '.bak' )
     phrase = linein( Resource || '.bak' )

     /* ****************************************************** */
     /* If found a line where the style of the notebook dialog */
     /* is being defined, add the OS/2 Warp v4.0 style         */
     /* ****************************************************** */
     position = pos('BKS_SPIRALBIND', phrase)
     if position > 0 then
          phrase = phrase || ' 0x800 | '

     /* ************************************ */
     /* Write the line read from .bak to .rc */
     /* ************************************ */
    junk =  lineout( Resource || '.rc', phrase)
end


/* **************************** */
/* Close the .bak and .rc files */
/* **************************** */
junk = lineout( Resource || '.rc' )
junk = lineout( Resource || '.bak' )


/* ******************** */
/* Delete the .bak file */
/* ******************** */
'del ' || Resource || '.bak'

