// Basic framework for a dialog as the main window

#define INCL_WIN
#define INCL_PM

#include <string.h>
#include <os2.h>

#include "Basic.hpp"
#include "Resource.h"

const char szClassName[]=PRODUCT;

//---------------------------------------------------------------------------------------------------------
//Function prototypes

MRESULT EXPENTRY Dlg_Notebook( HWND hwnd, ULONG msg, MPARAM mp1, MPARAM mp2 );

//---------------------------------------------------------------------------------------------------------

main()
{
     BOOL Shutdown = FALSE;

     HAB hab = WinInitialize( 0 );
     if( hab ==NULLHANDLE )
     {
          WinMessageBox( HWND_DESKTOP,
                         HWND_DESKTOP,
                         (PSZ) "Unable to initialize dialog",
                         (PSZ) "ERROR!",
                         0,
                         MB_CANCEL | MB_ERROR );
          Shutdown = TRUE;
     }

     HMQ hmq = WinCreateMsgQueue( hab, 0 );
     if( hmq == NULLHANDLE)
     {
          WinMessageBox( HWND_DESKTOP,
                         HWND_DESKTOP,
                         (PSZ) "Unable to create a message queue",
                         (PSZ) "ERROR!",
                         0,
                         MB_CANCEL | MB_ERROR );
          Shutdown = TRUE;
     }

     if( !WinRegisterClass( hab, szClassName, Dlg_Notebook, CS_SIZEREDRAW, 4 ) )
     {
          WinMessageBox( HWND_DESKTOP,
                         HWND_DESKTOP,
                         (PSZ) "Unable to register dialog class",
                         (PSZ) "ERROR!",
                         0,
                         MB_CANCEL | MB_ERROR );
          Shutdown = TRUE;
     }

     HWND hwndFrame = WinLoadDlg( HWND_DESKTOP,
                                  HWND_DESKTOP,
                                  Dlg_Notebook,
                                  0,
                                  DLG_NOTEBOOK, NULL );
     if( hwndFrame == NULLHANDLE )
     {
          WinMessageBox( HWND_DESKTOP,
                         HWND_DESKTOP,
                         (PSZ) "Unable to create main dialog",
                         (PSZ) "ERROR!",
                         0,
                         MB_CANCEL | MB_ERROR );
          Shutdown = TRUE;
     }

     PID pid;
     WinQueryWindowProcess( hwndFrame, &pid, NULL );

     // Add the dialog to the switch list
     SWCNTRL swctrl;
     swctrl.hwnd = hwndFrame;
     swctrl.hwndIcon = NULLHANDLE;
     swctrl.hprog = NULLHANDLE;// Use the value attributed by the system when the program was loaded
     swctrl.idProcess = pid;
     swctrl.idSession = 0;// Use the current process ID
     swctrl.uchVisibility = SWL_VISIBLE;
     swctrl.fbJump = SWL_JUMPABLE;
     strcpy( swctrl.szSwtitle, PRODUCT );
     swctrl.bProgType = PROG_PM;

     HSWITCH hswitch = WinAddSwitchEntry( &swctrl );

     QMSG qmsg;
     while( !Shutdown )
     {
          // Standard message loop
          // The while loop is exited when a WM_QUIT message is received
          while(WinGetMsg(hab, &qmsg, 0, 0, 0))
               WinDispatchMsg(hab, &qmsg);

          // Let's see if we can safely close the dialog
          if( WinSendMsg( hwndFrame, WM_VERIFYSHUTDOWN, 0, 0 ) )
               // Work has been saved or discarded
               // And it is save to shutdown the application
               Shutdown = TRUE;

          if( qmsg.hwnd == NULLHANDLE && !Shutdown )
               // The work has not been saved or the user
               // cancelled the shutdown
               WinCancelShutdown( hmq, FALSE );
     }
     WinDestroyWindow(hwndFrame);
     WinDestroyMsgQueue(hmq);
     WinTerminate(hab);

     return 0;
}//end of main

