// Dialog procedure for a notebook page

#define INCL_WIN
#define INCL_PM

#include <stdlib.h>
#include <os2.h>

#include "Basic.hpp"
#include "Resource.h"

//------------------------------------------------------------------------

MRESULT EXPENTRY Dlg_NbkpPage ( HWND hwnd, ULONG msg, MPARAM mp1, MPARAM mp2 )
{
     switch( msg )
     {
     //----------------------------------
     case WM_CLOSE:
          // Release dynamic allocations
          InfoBox( "Closing a notebook page" );
          break;
     //----------------------------------
     case WM_COMMAND:
          switch( SHORT1FROMMP( mp1 ) )
          {
               case PB_UNDO:
                    // The undo pushbutton has been pressed
                    // The entries should be reset to their last saved values

                    InfoBox( "PB_UNDO in a notebook page" );
                    break;
                //----------------------------------
               case PB_DEFAULT:
                    // The default pushbutton has been pressed
                    // The entries should be reset to their default values

                    InfoBox( "PB_DEFAULT in a notebook page" );
                    break;
                //----------------------------------
          }
          return 0;
     //----------------------------------
     case WM_VALIDATE:
          // Validate the entries

          InfoBox( "Validating a notebook page" );
          // Returns from WinQueryButtonCheckstate are:
          //      0.  Checkbox is clear:  no validation error
          //      1.  Checkbox is checked:  validation error
          // WM_VALIDATE will return TRUE if there is no validation error
          // and FALSE if there is a validation error
          return (MPARAM) !WinQueryButtonCheckstate( hwnd, CKB_VALIDATIONERROR );
     }//switch( msg )

     return WinDefDlgProc( hwnd, msg, mp1, mp2 );

}// Dlg_NbkpPage Dialog Procedure
